/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_ArterialVenousContent;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_ArterialVenousContent;


/**
 * This class represents ArterialVenousContent - CID3529
 */
public class ArterialVenousContent_CID3529 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * Instantiates a new ArterialVenousContent_CID3529 Template 
	 */
	public ArterialVenousContent_CID3529()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumArterialVenousContent Object of EnumCM_ArterialVenousContent represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_ArterialVenousContent enumArterialVenousContent)
	{
		switch(enumArterialVenousContent)
		{
		case ARTERIAL_CONTENT_FCA: this.strCodeValue =EnumCV_ArterialVenousContent.ARTERIAL_CONTENT_FCA_19218_7.getValue(); break;
		case VENOUS_CONTENT_FCV: this.strCodeValue =EnumCV_ArterialVenousContent.VENOUS_CONTENT_FCV_19220_3.getValue(); break;
		case PULMONARY_ARTERIAL_CONTENT_FCPA: this.strCodeValue =EnumCV_ArterialVenousContent.PULMONARY_ARTERIAL_CONTENT_FCPA_122188.getValue(); break;
		case PULMONARY_VENOUS_CONTENT_FCPV: this.strCodeValue =EnumCV_ArterialVenousContent.PULMONARY_VENOUS_CONTENT_FCPV_122189.getValue(); break;
		}
	}

	/**
	 * Sets the value for ArterialVenousContent
	 * @param enumArterialVenousContent Object of EnumCM_ArterialVenousContent.
	 */
	public void setArterialVenousContent(EnumCM_ArterialVenousContent enumArterialVenousContent)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumArterialVenousContent.getValue();
		if(enumArterialVenousContent.getValue().equalsIgnoreCase(EnumCM_ArterialVenousContent.ARTERIAL_CONTENT_FCA.getValue())
				||enumArterialVenousContent.getValue().equalsIgnoreCase(EnumCM_ArterialVenousContent.VENOUS_CONTENT_FCV.getValue()))
		{
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.LN.getValue();
		}
		else
		{
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		}
		
		/**
		 * set code Value
		 */
		setCodeValue(enumArterialVenousContent);
	}
}
